; We use four segments, one for the code, two for miscellaneous data and one for the sprite data
                segment data = $5B00,$016F      ; Starts at $5B00, end before $5C70
                segment data_a = $5C70,$75FF-$5C70 ; Starts at $5C70, end before $7600
                segment code = $7600,$B2FF - $7600 ; Starts at $7600, end before $B300 (the sprites start there)
                segment sprites = $B300,$F9FF - $B300 ; Starts at $B300, ends before $FA00

pLinkF          EQU     $00
pLinkB          EQU     $02
pSprNo          EQU     $04
pXDraw          EQU     $05
pWidth          EQU     $06
pYDraw          EQU     $07
pHeight         EQU     $08

pXReal          EQU     $09
pXSize          EQU     $0A
pYReal          EQU     $0B
pYSize          EQU     $0C
pZReal          EQU     $0D
pZSize          EQU     $0E

pLinkColl       EQU     $0F

pObjType        EQU     $11

pXFrom          EQU     $12
pYFrom          EQU     $13
pZFrom          EQU     $14
pXTo            EQU     $15
pYTo            EQU     $16
pZTo            EQU     $17

pLinkAnim       EQU     $18
pAnimRout       EQU     $1A

pHitType        EQU     $1C
pAnPower        EQU     $1C

pManRoom        EQU     $1D
pDirect         EQU     $1F
pAnimStep       EQU     $20
pPower          EQU     $21
pLastPower      EQU     $22
pPickSprite     EQU     $23
pPickType       EQU     $24
pWeapSprite     EQU     $25
pWeapType       EQU     $26
pDrunk          EQU     $27
pName           EQU     $28

Death           EQU     $07     ;$80
Pick            EQU     $06     ;$20

PickType        EQU     $40
DoorType        EQU     $20
FrameType       EQU     $10

BlockType       EQU     $01
StairType       EQU     $02
RatType         EQU     $03
DogType         EQU     $04
MoveType        EQU     $05
LadderType      EQU     $06
SpiderType      EQU     $07
BatType         EQU     $09
DogYType        EQU     $0A
AltMoveType     EQU     $0B
WisType         EQU     $2F
ManType         EQU     $1F
NosyType        EQU     $9F

MaxPower        EQU     $9C

ManSprite       EQU     $30
LucySprite      EQU     $40
NosySprite      EQU     $4A
GunSprite       EQU     $22
SwordSprite     EQU     $23
StakeSprite     EQU     $21
LampSprite      EQU     $1E
LitLamp         EQU     $1F
BottleSprite    EQU     $27
WaterSprite     EQU     $1A
CoffinSprite    EQU     $0A
MoonSprite      EQU     $0C
WindowSprite    EQU     $0B
LockSpr1        EQU     $7F
KeySpr1         EQU     $1D
CandelSprite    EQU     $19
CheeseSprite    EQU     $1B
BiscuitSprite   EQU     $1C
AxeSprite       EQU     $25
DeedSprite      EQU     $26
BootSprite      EQU     $60
MatchSprite     EQU     $61
GarlicSprite    EQU     $62
BreadSprite     EQU     $63
ChairSprite     EQU     $04
IgnoreSprite    EQU     $7D
CrucifixSprite  EQU     $24

pNumber         EQU     $00
pScene          EQU     $02
pComps          EQU     $04
pColour         EQU     $06
pFloor          EQU     $06
pConnect        EQU     $07
pWall           EQU     $08

RoomSize        EQU     $0009

Offset          EQU     $0040

DummyWidth      EQU     $0005

SprSet          EQU     $B300   ;1
DummyScreen     EQU     $FA00   ;1
IntPage         EQU     $FC00   ;1
StartStack      EQU     $FDFD   ;1
RevTable        EQU     $FE00   ;1
MaskTable       EQU     $FF00   ;1
DisplayFile     EQU     $4000   ;1

