                segment code

XYMaxMan        EQU     $3A
NewMax          EQU     $41

                segment data

ManList:        DEFW    JohnList

JohnList:       DEFW    $0000
                DEFW    $0000
                DEFB    ManSprite
                DEFB    $00,$0C
                DEFB    $00,$18
                DEFB    $38,$06
                DEFB    $20,$06
                DEFB    $30,$10
                DEFW    $0000
                DEFB    ManType
                DEFB    $00,$00,$00
                DEFB    $00,$00,$00
                DEFW    $0000
                DEFW    $0000
                DEFB    $00
                DEFW    $0078
                DEFB    $01
                DEFB    $00
                DEFB    $40,$00
                DEFB    $00,$00
                DEFB    $00,$00
                DEFB    $00
                DEFB    "  Jonathan ",$FF

LucyList:       DEFW    $0000
                DEFW    $0000
                DEFB    LucySprite
                DEFB    $00,$0C
                DEFB    $00,$18
                DEFB    $38,$06
                DEFB    $20,$06
                DEFB    $30,$10
                DEFW    $0000
                DEFB    ManType
                DEFB    $00,$00,$00
                DEFB    $00,$00,$00
                DEFW    $0000
                DEFW    $0000
                DEFB    $00
                DEFW    $0E78
                DEFB    $01
                DEFB    $00
                DEFB    $40,$00
                DEFB    $00,$00
                DEFB    $00,$00
                DEFB    $00
                DEFB    "    Lucy   ",$FF

VanList:        DEFW    $0000
                DEFW    $0000
                DEFB    ManSprite
                DEFB    $00,$0C
                DEFB    $00,$18
                DEFB    $38,$06
                DEFB    $20,$06
                DEFB    $30,$10
                DEFW    $0000
                DEFB    ManType
                DEFB    $00,$00,$00
                DEFB    $00,$00,$00
                DEFW    $0000
                DEFW    $0000
                DEFB    $00
                DEFW    $0E78
                DEFB    $01
                DEFB    $00
                DEFB    $40,$00
                DEFB    $00,$00
                DEFB    $00,$00
                DEFB    $00
                DEFB    "Van Helsing",$FF

NosyList:       DEFW    $0000
                DEFW    $0000
                DEFB    NosySprite
                DEFB    $00,$0C
                DEFB    $00,$18
                DEFB    $38,$06
                DEFB    $20,$06
                DEFB    $30,$10
                DEFW    $0000
                DEFB    NosyType
                DEFB    $00,$00,$00
                DEFB    $00,$00,$00
                DEFW    $0000
                DEFW    $0000
                DEFB    $00
                DEFW    $0E78
                DEFB    $01
                DEFB    $00
                DEFB    $40,$00

                segment code

MultiCheck:     LD      HL,BounceTable+$0A
                CALL    ReadKey
                AND     $01
                LD      B,A
                LD      HL,BounceTable+$0C
                CALL    ReadKey
                AND     $02
                OR      B
                LD      B,A
                LD      HL,BounceTable+$0E
                CALL    ReadKey
                AND     $04
                OR      B
                LD      B,A
                RET     Z
                CP      $01
                JR      Z,ChangeToJohn
                CP      $02
                JR      Z,ChangeToLucy
                CP      $04
                RET     NZ
                LD      HL,(ManList)
                LD      DE,VanList
                OR      A
                SBC     HL,DE
                RET     Z
                JP      DoNew

ChangeToJohn:   LD      HL,(ManList)
                LD      DE,JohnList
                OR      A
                SBC     HL,DE
                RET     Z
                JP      DoNew

ChangeToLucy:   LD      HL,(ManList)
                LD      DE,LucyList
                OR      A
                SBC     HL,DE
                RET     Z
DoNew:          LD      IX,(ManList)
                PUSH    IX
                LD      L,(IX+pManRoom+$00)
                LD      H,(IX+pManRoom+$01)
                PUSH    DE
                POP     IX
                LD      (ManList),DE
                LD      E,(IX+pManRoom+$00)
                LD      D,(IX+pManRoom+$01)
                OR      A
                SBC     HL,DE
                JR      Z,SameRoom
                LD      A,D
                ADD     A,(IX+pZReal)
                LD      D,A
                CALL    GetRoomPnt
                LD      A,H
                OR      L
                JR      Z,BadNew
                LD      A,$00
                LD      (Following),A
                CALL    NewRoom
                POP     IX
                RET

BadNew:         POP     IX
                LD      (ManList),IX
                RET

SameRoom:       CALL    TakeAnim
                POP     IX
                LD      (IX+pAnimRout+$00),LOW ManAnim
                LD      (IX+pAnimRout+$01),HIGH ManAnim
                CALL    AddAnim
                CALL    PrintName
                RET

MoveMan:        LD      IX,(ManList)
                LD      A,(IX+pPower)
                CP      (IX+pLastPower)
                LD      (IX+pLastPower),A
                CALL    NZ,DrawPower
                LD      HL,DoTheMove
                CALL    DealWAnim
                RET

DropAllObjects: LD      A,(IX+pSprNo)
                CP      CrucifixSprite
                SCF
                RET     Z
                LD      B,$04
DropAll:        PUSH    BC
                CALL    TryDropping
                LD      A,(IX+pDirect)
                AND     $03
                INC     A
                LD      (IX+pDirect),A
                POP     BC
                DJNZ    DropAll
                LD      (IX+pSprNo),CrucifixSprite
                CALL    GetSize
                CALL    RePosition
                CALL    ZeroTos
                OR      A
                RET

CheckEndTwo:    LD      HL,(ManList)
                LD      DE,LucyList
                OR      A
                SBC     HL,DE
                RET     NZ
                LD      E,(IX+pManRoom+$00)
                LD      D,(IX+pManRoom+$01)
                LD      HL,$188B
                OR      A
                SBC     HL,DE
                RET     NZ
                LD      A,(NosyList+pManRoom+$00)
                LD      E,A
                LD      A,(NosyList+pManRoom+$01)
                LD      D,A
                LD      HL,$188B
                OR      A
                SBC     HL,DE
                RET     NZ
                LD      A,(Seconds)
                OR      A
                RET     M
                LD      A,$03
                JP      EndGame

DoTheMove:      LD      A,(IX+pPower)
                OR      A
                JR      Z,DropAllObjects
                CALL    CheckEndTwo
                LD      A,$00
                LD      (SortFlag),A
                LD      A,(IX+pZFrom)
                CALL    ZeroFroms
                DEC     A
                JP      P,NoGravity
                CALL    Gravity
                JR      NC,FullGravity
NoGravity:      CALL    CheckMove
                CALL    TryPick
FullGravity:    LD      A,(IX+pDrunk)
                OR      A
                CALL    NZ,ManPissed
                CALL    TryXMove
                JR      C,NewRoomHack
                LD      B,(IX+pXTo)
                PUSH    BC
                LD      (IX+pXTo),$00
                CALL    TryYMove
                POP     BC
                JR      C,NewRoomHack
                PUSH    BC
                CALL    TryXMove
                POP     BC
                JR      C,NewRoomHack
                LD      A,(IX+pXTo)
                ADD     A,B
                LD      (IX+pXTo),A
                CALL    TryZMove
                JR      C,NewRoomHack
                CALL    TransferTos
                LD      A,(SortFlag)
                ADD     A,A
                CCF
                RET     C
                CALL    SortDrawList
                OR      A
                RET

NewRoomHack:    CALL    ZeroFroms
ZeroTos:        LD      (IX+pXTo),$00
                LD      (IX+pYTo),$00
                LD      (IX+pZTo),$00
                SCF
                RET

ZeroFroms:      LD      (IX+pXFrom),$00
                LD      (IX+pYFrom),$00
                LD      (IX+pZFrom),$00
                RET

ManPissed:      LD      A,(IX+pXTo)
                OR      A
                JR      NZ,NotPissedX
                LD      A,(IX+pYTo)
                OR      A
                JR      Z,NotPissedX
                LD      A,R
                AND     $7F
                CP      $20
                RET     NC
                CP      $10
                SBC     A,A
                ADD     A,A
                INC     A
                ADD     A,(IX+pXTo)
                LD      (IX+pXTo),A
                DEC     (IX+pDrunk)
                RET

NotPissedX:     LD      A,(IX+pYTo)
                OR      A
                RET     NZ
                LD      A,(IX+pXTo)
                OR      A
                RET     Z
                LD      A,R
                AND     $7F
                CP      $20
                RET     NC
                CP      $10
                SBC     A,A
                ADD     A,A
                INC     A
                ADD     A,(IX+pYTo)
                LD      (IX+pYTo),A
                DEC     (IX+pDrunk)
                RET

PutInFront:     LD      A,(IY+pDirect)
                ADD     A,A
                LD      E,A
                LD      D,$00
                LD      HL,MoveTable
                ADD     HL,DE
                LD      D,(IY+pXReal)
                LD      A,(HL)
                ADD     A,A
                ADD     A,(HL)
                ADD     A,A
                ADD     A,D
                LD      (IX+pXReal),A
                LD      E,(IY+pYReal)
                INC     HL
                LD      A,(HL)
                ADD     A,A
                ADD     A,(HL)
                ADD     A,A
                ADD     A,E
                LD      (IX+pYReal),A
                LD      A,(IY+pZReal)
                LD      (IX+pZReal),A
                RET

DrawRound:      PUSH    IX
                LD      D,(IX+pXDraw)
                LD      E,(IX+pWidth)
                LD      H,(IX+pYDraw)
                LD      L,(IX+pHeight)
                CALL    DrawWindow
                POP     IX
                RET

DoDropping:     LD      IX,(ManList)
TryDropping:    PUSH    IX
                PUSH    IX
                CALL    CheckNear
                POP     IY
                JR      C,EndTryDrop
                LD      IX,(ObjFree)
                LD      A,(IY+pPickSprite)
                OR      A
                JR      Z,TryWeap
                PUSH    AF
                PUSH    IX
                LD      DE,DropTune
                LD      A,$01
                CALL    AddTune
                POP     IX
                POP     AF
                LD      (IX+pSprNo),A
                LD      (IX+pObjType),PickType
                LD      (IY+pPickSprite),$00
                LD      (IY+pPickType),$00
                CALL    PutInFront
                CALL    GetSize
                CALL    RePosition
                CALL    AddDraw
                CALL    AddColl
                CALL    DrawRound
                LD      DE,pXFrom
                ADD     IX,DE
                LD      (ObjFree),IX
                CALL    DrawPick
EndTryDrop:     POP     IX
                RET

TryWeap:        LD      A,(IY+pWeapSprite)
                OR      A
                JR      Z,NoDropWeap
                PUSH    AF
                PUSH    IX
                LD      DE,DropTune
                LD      A,$01
                CALL    AddTune
                POP     IX
                POP     AF
                LD      (IX+pSprNo),A
                LD      (IX+pObjType),PickType
                LD      (IY+pWeapSprite),$00
                LD      (IY+pWeapType),$00
                CALL    PutInFront
                CALL    GetSize
                CALL    RePosition
                CALL    AddDraw
                CALL    AddColl
                CALL    DrawRound
                LD      DE,pXFrom
                ADD     IX,DE
                LD      (ObjFree),IX
                CALL    DrawWeap
NoDropWeap:     POP     IX
                RET

TryPick:        LD      A,(IX+pWeapSprite)
                INC     A
                JR      NZ,NotDeadWeap
                LD      (IX+pWeapSprite),$00
                PUSH    IX
                CALL    DrawWeap
                POP     IX
NotDeadWeap:    LD      HL,BounceTable+$08
                CALL    ReadKey
                RET     Z
                CALL    CheckNear
                JP      NC,DoDropping
                JP      Z,NoPickUp
                LD      A,(IX+pSprNo)
                AND     $7F
                CP      IgnoreSprite
                JP      NC,KillKey
                PUSH    AF
                PUSH    IX
                LD      DE,PickTune
                LD      A,$01
                CALL    AddTune
                POP     IX
                POP     AF
                CALL    CheckFood
                JP      Z,PickedFood
                LD      IY,(ManList)
                CP      BottleSprite
                JP      Z,MoreDrunk
                CP      MatchSprite
                JP      Z,LightLamp
                CP      LampSprite
                JP      Z,LightLamp
                CP      AxeSprite
                JP      Z,MakeStake
                CP      ChairSprite+$01
                JP      C,MakeStake
NoCombine:      LD      B,(IX+pXDraw)
                LD      A,B
                ADD     A,(IX+pWidth)
                LD      C,A
                PUSH    BC
                LD      B,(IX+pYDraw)
                LD      A,B
                ADD     A,(IX+pHeight)
                LD      C,A
                PUSH    BC
                LD      A,(IX+pSprNo)
                CALL    CheckWeap
                JR      Z,SwapAWeap
                CALL    SwapPick
                JP      DoneSwap
SwapAWeap:      CALL    SwapWeap
DoneSwap:       LD      A,(IX+pSprNo)
                OR      A
                CALL    Z,NoOldSprite
                PUSH    AF
                CALL    NZ,RePosition
                POP     AF
                POP     HL
                POP     DE
                JR      Z,UseHeight2
                LD      B,(IX+pXDraw)
                LD      A,B
                ADD     A,(IX+pWidth)
                LD      C,A
                LD      A,D
                CP      B
                JR      C,UseWidth1
                LD      D,B
UseWidth1:      LD      A,E
                CP      C
                JR      NC,UseWidth2
                LD      E,C
UseWidth2:      LD      B,(IX+pYDraw)
                LD      A,B
                ADD     A,(IX+pHeight)
                LD      C,A
                LD      A,H
                CP      B
                JR      C,UseHeight1
                LD      H,B
UseHeight1:     LD      A,L
                CP      C
                JR      NC,UseHeight2
                LD      L,C
UseHeight2:     LD      A,L
                SUB     H
                LD      L,A
                LD      A,E
                SUB     D
                LD      E,A
                CALL    DrawWindow
                CALL    DrawPick
                CALL    DrawWeap
                LD      IX,(ManList)
                LD      A,(RoomColour)
                CALL    SetUpULA
                RET

CheckNear:      PUSH    IX
                LD      A,(IX+pDirect)
                ADD     A,A
                LD      E,A
                LD      D,$00
                LD      HL,MoveTable
                ADD     HL,DE
                LD      D,(IX+pXReal)
                LD      A,(HL)
                ADD     A,A
                ADD     A,(HL)
                ADD     A,A
                ADD     A,D
                LD      (IX+pXReal),A
                LD      E,(IX+pYReal)
                INC     HL
                PUSH    DE
                LD      A,(HL)
                ADD     A,A
                ADD     A,(HL)
                ADD     A,A
                ADD     A,E
                LD      (IX+pYReal),A
                LD      D,IXH
                LD      E,IXL
                CALL    PickCollide
                POP     DE
                POP     IY
                LD      (IY+pXReal),D
                LD      (IY+pYReal),E
                RET

LightLamp:      LD      A,(IX+pSprNo)
                CP      LampSprite
                JR      Z,ObjIsLamp
                CP      MatchSprite
                JP      NZ,NoCombine
                JP      ObjIsMatch
ObjIsLamp:      LD      A,(IY+pPickSprite)
                CP      MatchSprite
                JP      NZ,NoCombine
                JP      DoLampLit
ObjIsMatch:     LD      A,(IY+pPickSprite)
                CP      LampSprite
                JP      NZ,NoCombine
DoLampLit:      LD      DE,$0064
                CALL    AddScore
                LD      (IY+pPickSprite),$00
                LD      (IY+pPickType),$00
                LD      (IX+pSprNo),LitLamp
                LD      (IX+pObjType),PickType
                JP      NoCombine

MakeStake:      LD      A,(IX+pSprNo)
                AND     $7F
                CP      AxeSprite
                JR      Z,ObjIsAxe
                CP      ChairSprite+$01
                JP      NC,NoCombine
                JP      ObjIsChair
ObjIsAxe:       LD      A,(IY+pPickSprite)
                AND     $7F
                JP      Z,NoCombine
                CP      ChairSprite+$01
                JP      NC,NoCombine
                JP      DoMakeStake
ObjIsChair:     LD      A,(IY+pPickSprite)
                AND     $7F
                JP      Z,NoCombine
                CP      AxeSprite
                JP      NZ,NoCombine
DoMakeStake:    LD      DE,$000A
                CALL    AddScore
                LD      (IY+pPickSprite),AxeSprite
                LD      (IY+pPickType),PickType
                LD      (IX+pSprNo),StakeSprite
                LD      (IX+pObjType),PickType
                JP      NoCombine

SwapWeap:       LD      IY,(ManList)
                LD      C,(IY+pWeapSprite)
                LD      B,(IY+pWeapType)
                LD      A,(IX+pSprNo)
                LD      (IY+pWeapSprite),A
                LD      A,(IX+pAnPower)
                LD      (IY+pWeapType),A
                LD      (IX+pSprNo),C
                LD      (IX+pObjType),PickType
                LD      (IX+pAnPower),B
                RET

SwapPick:       LD      IY,(ManList)
                LD      C,(IY+pPickSprite)
                LD      B,(IY+pPickType)
                LD      A,(IX+pSprNo)
                LD      (IY+pPickSprite),A
                LD      A,(IX+pAnPower)
                LD      (IY+pPickType),A
                LD      (IX+pSprNo),C
                LD      (IX+pAnPower),B
                LD      (IX+pObjType),PickType
                RET

KillPick:       CALL    NoOldSprite
                LD      H,(IX+pYDraw)
                LD      L,(IX+pHeight)
                LD      D,(IX+pXDraw)
                LD      E,(IX+pWidth)
                CALL    DrawWindow
                CALL    DrawPick
                CALL    DrawWeap
                LD      IX,(ManList)
                RET

NoOldSprite:    CALL    TakeColl
                CALL    TakeDraw
                CALL    TakeAnim
                PUSH    IX
                POP     HL
                LD      DE,pXFrom
                ADD     HL,DE
                LD      DE,(ObjFree)
                OR      A
                SBC     HL,DE
                JR      NZ,SkipNoOld
                LD      (ObjFree),IX
SkipNoOld:      XOR     A
                RET

MoreDrunk:      LD      A,(IY+pDrunk)
                ADD     A,$60
                JP      C,KillPick
                LD      (IY+pDrunk),A
                JP      KillPick

PickedFood:     LD      IY,(ManList)
                LD      A,(IY+pPower)
                ADD     A,C
                CP      MaxPower
                JR      C,PowerOkay
                LD      A,MaxPower
PowerOkay:      LD      (IY+pPower),A
                JP      KillPick

KillKey:        CP      LockSpr1
                JR      NZ,NoPickUp
                LD      IY,(ManList)
                LD      A,(IY+pPickSprite)
                CP      KeySpr1
                JR      NZ,NoPickUp
                LD      (IY+pPickSprite),$00
                LD      (IY+pPickType),$00
                CALL    TakeColl
                CALL    DrawPick
NoPickUp:       LD      IX,(ManList)
                RET

CheckWeap:      CP      GunSprite
                RET     Z
                CP      StakeSprite
                RET     Z
                CP      SwordSprite
                RET     Z
                CP      BootSprite
                RET

CheckFood:      LD      C,$10
                CP      WaterSprite
                RET     Z
                LD      C,$20
                CP      CheeseSprite
                RET     Z
                LD      C,$18
                CP      BiscuitSprite
                RET     Z
                LD      C,$18
                CP      BreadSprite
                RET

TryXMove:       LD      A,(IX+pXTo)
                OR      A
                RET     Z
                LD      (IX+pHitType),$00
                LD      (IX+pXFrom),A
                LD      C,A
                LD      A,(IX+pXReal)
                PUSH    AF
                ADD     A,C
                LD      (IX+pXReal),A
                PUSH    IX
                POP     DE
                CALL    ScnCollide
                JR      NC,HackX
                LD      HL,pHitType
                ADD     HL,DE
                LD      A,(HL)
                CP      DoorType
                JR      Z,DoorWayX
                CP      DoorType OR FrameType
                JR      Z,DoorWayX
                BIT     7,(IX+pObjType)
                CALL    NZ,DeathRout
                JR      HitXMove
HackX:          CALL    WallCollide
                JR      C,HitXMove
DoorWayX:       PUSH    DE
                POP     IX
                CALL    CheckNewRoom
                JR      C,NewRoomX
                POP     AF
                LD      (IX+pXFrom),$00
                LD      A,$FF
                LD      (SortFlag),A
                OR      A
                RET

HitXMove:       PUSH    DE
                POP     IX
                POP     AF
                LD      (IX+pXReal),A
                LD      (IX+pXFrom),$00
                LD      (IX+pXTo),$00
                OR      A
                RET

NewRoomX:       POP     AF
                LD      (IX+pXFrom),$00
                SCF
                RET

TryYMove:       LD      A,(IX+pYTo)
                OR      A
                RET     Z
                LD      (IX+pHitType),$00
                LD      (IX+pYFrom),A
                LD      C,A
                LD      A,(IX+pYReal)
                PUSH    AF
                ADD     A,C
                LD      (IX+pYReal),A
                PUSH    IX
                POP     DE
                CALL    ScnCollide
                JR      NC,HackY
                LD      HL,pHitType
                ADD     HL,DE
                LD      A,(HL)
                CP      DoorType
                JR      Z,DoorWayY
                CP      DoorType OR FrameType
                JR      Z,DoorWayX
                BIT     7,(IX+pObjType)
                CALL    NZ,DeathRout
                JR      HitYMove
HackY:          CALL    WallCollide
                JR      C,HitYMove
DoorWayY:       PUSH    DE
                POP     IX
                CALL    CheckNewRoom
                JR      C,NewRoomY
                POP     AF
                LD      (IX+pYFrom),$00
                LD      A,$FF
                LD      (SortFlag),A
                OR      A
                RET
HitYMove:       PUSH    DE
                POP     IX
                POP     AF
                LD      (IX+pYReal),A
                LD      (IX+pYFrom),$00
                LD      (IX+pYTo),$00
                OR      A
                RET
NewRoomY:       POP     AF
                LD      (IX+pYFrom),$00
                SCF
                RET

TryZMove:       LD      A,(IX+pZTo)
                OR      A
                RET     Z
                LD      (IX+pZFrom),A
                LD      C,A
                LD      A,(IX+pZReal)
                PUSH    AF
                ADD     A,C
                LD      (IX+pZReal),A
                PUSH    IX
                POP     DE
                CALL    ScnCollide
                JR      NC,HackZ
                LD      HL,pHitType
                ADD     HL,DE
                BIT     7,(HL)
                CALL    NZ,DeathRout
                JR      HitZMove
HackZ:          CALL    WallCollide
                JR      C,HitZMove
                PUSH    DE
                POP     IX
                POP     AF
                LD      (IX+pZFrom),$00
                LD      A,$FF
                LD      (SortFlag),A
                OR      A
                RET
HitZMove:       PUSH    DE
                POP     IX
                POP     AF
                LD      (IX+pZReal),A
                LD      (IX+pZFrom),$00
                LD      (IX+pZTo),$00
                OR      A
                RET

DeathRout:      PUSH    AF
                PUSH    BC
                PUSH    DE
                PUSH    HL
                PUSH    IY
                PUSH    IX
                LD      IY,(ManList)
                LD      B,NumDeaths
                LD      A,(IX+pObjType)
                LD      HL,DeathTable
                LD      DE,$0003
DeathLoop:      CP      (HL)
                JR      Z,GotDeathType
                ADD     HL,DE
                DJNZ    DeathLoop
                JR      EndDeath
GotDeathType:   INC     HL
                LD      E,(HL)
                INC     HL
                LD      D,(HL)
                EX      DE,HL
                LD      A,(IY+pWeapSprite)
                AND     $7F
                CALL    CallHLMM
                LD      A,(BounceTable+$08)
                OR      A
                LD      A,$FF
                JR      Z,NoFight
                LD      A,(IX+pAnPower)
                SUB     C
                JR      NC,DecedOther
                LD      A,$00
DecedOther:     LD      (IX+pAnPower),A
                OR      A
                CALL    Z,AddScore
NoFight:        PUSH    AF
                LD      A,(IY+pPower)
                SUB     B
                JR      NC,DecedMan
                LD      A,$00
DecedMan:       LD      (IY+pPower),A
                LD      DE,HitTune
                LD      A,B
                OR      A
                LD      A,$01
                CALL    NZ,AddTune
                POP     AF
                OR      A
                LD      DE,KillItTune
                LD      A,$01
                CALL    Z,AddTune
EndDeath:       POP     IX
                POP     IY
                POP     HL
                POP     DE
                POP     BC
                POP     AF
                RET

CallHLMM:       JP      (HL)

NumDeaths       EQU     $07

DeathTable:     DEFB    DogType+$80
                DEFW    DogDeath
                DEFB    DogYType+$80
                DEFW    DogDeath
                DEFB    RatType+$80
                DEFW    RatDeath
                DEFB    BatType+$80
                DEFW    BatDeath
                DEFB    SpiderType+$80
                DEFW    SpiderDeath
                DEFB    NosyType
                DEFW    NosyDeath
                DEFB    WisType+$80
                DEFW    WisDeath

DogDeath:       LD      DE,$0014
                LD      BC,$0801
                CP      SwordSprite
                JR      Z,SwordDog
                CP      GunSprite
                RET     NZ
                CALL    DecWeapon
                LD      BC,$0206
                RET

SwordDog:       CALL    DecWeapon
                LD      BC,$000A
                RET

RatDeath:       LD      DE,$0005
                LD      BC,$0301
                CP      SwordSprite
                JR      Z,SwordRat
                CP      GunSprite
                RET     NZ
                CALL    DecWeapon
                LD      BC,$0206
                RET

SwordRat:       CALL    DecWeapon
                LD      BC,$010A
                RET

BatDeath:       LD      DE,$0005
                LD      BC,$0204
                CP      SwordSprite
                RET     NZ
                CALL    DecWeapon
                LD      BC,$01FF
                RET

SpiderDeath:    LD      DE,$000A
                LD      BC,$0402
                CP      BootSprite
                RET     NZ
                LD      BC,$0008
                RET

NosyDeath:      LD      BC,$FF00
                RET

WisDeath:       LD      DE,$0064
                LD      BC,$1000
                CP      StakeSprite
                RET     NZ
                LD      A,(BounceTable+$08)
                OR      A
                RET     Z
                LD      (IY+pWeapSprite),$FF
                LD      BC,$00FF
                RET

DecWeapon:      LD      A,(BounceTable+$08)
                OR      A
                RET     Z
                DEC     (IY+pWeapType)
                LD      A,(IY+pWeapType)
                OR      A
                RET     NZ
                LD      (IY+pWeapSprite),$FF
                RET

CheckNewRoom:   CALL    CheckXNew
                RET     C
                CALL    CheckYNew
                RET

CheckFollow:    LD      A,(Following)
                OR      A
                SCF
                RET     Z
                LD      HL,(ManList)
                LD      DE,LucyList
                OR      A
                SBC     HL,DE
                SCF
                RET     NZ
                OR      A
                RET

CheckNewOkay:   PUSH    IX
                PUSH    IX
                POP     DE
                CALL    ScnCollide
                JR      NC,EndChkNew
                POP     IX
                LD      A,(IX+pHitType)
                CP      DoorType
                RET     Z
                CP      DoorType OR FrameType
                RET     Z
                SCF
                RET
EndChkNew:      POP     IX
                RET

CheckXNew:      LD      A,(IX+pXReal)
                OR      A
                JP      M,XNewOver
                ADD     A,(IX+pXSize)
                CP      NewMax
                CCF
                RET     NC
                CALL    CheckFollow
                JR      C,NotFollowX1
                LD      (IX+pXReal),$4A
                CALL    CheckNewOkay
                LD      (IX+pXReal),NewMax-$01-$06
                CCF
                RET     NC
                PUSH    IX
                LD      IX,NosyList
                LD      E,(IX+pXReal)
                PUSH    DE
                LD      (IX+pXReal),$40
                CALL    CheckNewOkay
                POP     DE
                LD      (IX+pXReal),E
                POP     IX
                CCF
                RET     NC
                LD      A,$00
                LD      (NosyList+pXReal),A
                LD      A,$0A
                JR      SaveX1
NotFollowX1:    LD      (IX+pXReal),$40
                CALL    CheckNewOkay
                LD      (IX+pXReal),NewMax-$01-$06
                CCF
                RET     NC
                LD      A,$00
SaveX1:         LD      (IX+pXReal),A
                LD      DE,$0010
                JP      DoNewRoom

XNewOver:       CALL    CheckFollow
                JR      C,NotFollowX2
                LD      (IX+pXReal),$F0
                CALL    CheckNewOkay
                LD      (IX+pXReal),$00
                CCF
                RET     NC
                PUSH    IX
                LD      IX,NosyList
                LD      E,(IX+pXReal)
                PUSH    DE
                LD      (IX+pXReal),$FA
                CALL    CheckNewOkay
                POP     DE
                LD      (IX+pXReal),E
                POP     IX
                CCF
                RET     NC
                LD      A,$3A
                LD      (NosyList+pXReal),A
                LD      A,$30
                JR      SaveX2

NotFollowX2:    LD      (IX+pXReal),$FA
                CALL    CheckNewOkay
                LD      (IX+pXReal),$00
                CCF
                RET     NC
                LD      A,XYMaxMan
SaveX2:         LD      (IX+pXReal),A
                LD      DE,$00F0
                JP      DoNewRoom

CheckYNew:      LD      A,(IX+pYReal)
                OR      A
                JP      M,YNewOver
                ADD     A,(IX+pYSize)
                CP      NewMax
                CCF
                RET     NC
                CALL    CheckFollow
                JR      C,NotFollowY1
                LD      (IX+pYReal),$4A
                CALL    CheckNewOkay
                LD      (IX+pYReal),NewMax-$01-$06
                CCF
                RET     NC
                PUSH    IX
                LD      IX,NosyList
                LD      E,(IX+pYReal)
                PUSH    DE
                LD      (IX+pYReal),$40
                CALL    CheckNewOkay
                POP     DE
                LD      (IX+pYReal),E
                POP     IX
                CCF
                RET     NC
                LD      A,$00
                LD      (NosyList+pYReal),A
                LD      A,$0A
                JR      SaveY1

NotFollowY1:    LD      (IX+pYReal),$40
                CALL    CheckNewOkay
                LD      (IX+pYReal),NewMax-$01-$06
                CCF
                RET     NC
                LD      A,$00
SaveY1:         LD      (IX+pYReal),$00
                LD      DE,$0001
                JP      DoNewRoom

YNewOver:       CALL    CheckFollow
                JR      C,NotFollowY2
                LD      (IX+pYReal),$F0
                CALL    CheckNewOkay
                LD      (IX+pYReal),$00
                CCF
                RET     NC
                PUSH    IX
                LD      IX,NosyList
                LD      E,(IX+pYReal)
                PUSH    DE
                LD      (IX+pYReal),$FA
                CALL    CheckNewOkay
                POP     DE
                LD      (IX+pYReal),E
                POP     IX
                CCF
                RET     NC
                LD      A,$3A
                LD      (NosyList+pYReal),A
                LD      A,$30
                JR      SaveY2

NotFollowY2:    LD      (IX+pYReal),$FA
                CALL    CheckNewOkay
                LD      (IX+pYReal),$00
                CCF
                RET     NC
                LD      A,XYMaxMan
SaveY2:         LD      (IX+pYReal),A
                LD      DE,$000F
DoNewRoom:      LD      L,(IX+pManRoom+$00)
                LD      A,(IX+pManRoom+$01)
                ADD     A,(IX+pZReal)
                LD      D,A
                PUSH    AF
                LD      A,E
                ADD     A,L
                AND     $0F
                LD      H,A
                LD      A,E
                AND     $F0
                ADD     A,L
                AND     $F0
                OR      H
                LD      E,A
                CALL    GetRoomPnt
                LD      HL,$A86A
                OR      A
                SBC     HL,DE
                JR      NZ,RoomOkay
                LD      A,(Seconds)
                OR      A
                RET     M
RoomOkay:       LD      (IX+pManRoom+$00),E
                LD      (IX+pManRoom+$01),D
                POP     AF
                SUB     D
                PUSH    AF
                PUSH    DE
                CALL    CheckFollow
                JR      C,NotEndFoll
                POP     DE
                POP     AF
                LD      (NosyList+pZReal),A
                PUSH    AF
                PUSH    DE
                LD      A,E
                LD      (NosyList+pManRoom+$00),A
                LD      A,D
                LD      (NosyList+pManRoom+$01),A
NotEndFoll:     POP     DE
                POP     AF
                LD      (IX+pZReal),A
                LD      A,$00
                LD      (Following),A
                CALL    NewRoom
                SCF
                RET

NosySprTable:   DEFB    NosySprite+$80,NosySprite+$86
                DEFB    NosySprite+$00,NosySprite+$06

LucySprTable:   DEFB    LucySprite+$80,LucySprite+$84
                DEFB    LucySprite+$00,LucySprite+$04

SpriteTable:    DEFB    ManSprite+$80,ManSprite+$88
                DEFB    ManSprite+$00,ManSprite+$08

NosyStepList:   DEFB    $02,$FE,$02,$FE

LucyStepList:   DEFB    $02,$00,$FE,$00

StepList:       DEFB    $02,$02,$02,$FA

MoveTable:      DEFB    $00,$00
                DEFB    $FF,$00
                DEFB    $01,$00
                DEFB    $00,$FF
                DEFB    $00,$01

NewDirect:      LD      (IX+pDirect),A
StaticSprite:   LD      A,(IX+pDirect)
                DEC     A
                LD      E,A
                LD      D,$00
                LD      HL,SpriteTable
                LD      A,(IX+pSprNo)
                AND     $7F
                CP      LucySprite
                JR      C,MenSprite
                LD      HL,LucySprTable
                CP      NosySprite
                JR      C,MenSprite
                LD      HL,NosySprTable
MenSprite:      ADD     HL,DE
                LD      A,(IX+pSprNo)
                CP      (HL)
                RET     Z
                LD      A,(HL)
                LD      (IX+pSprNo),A
                LD      A,$00
                LD      (IX+pAnimStep),A
                LD      A,$FF
                LD      (SortFlag),A
                RET

CheckMove:      CALL    GetDirect
ChkMovePlus:    OR      A
                JR      Z,StaticSprite
                CP      (IX+pDirect)
                JR      NZ,NewDirect
                ADD     A,A
                LD      E,A
                LD      D,$00
                LD      HL,MoveTable
                ADD     HL,DE
                LD      A,(IX+pXTo)
                ADD     A,(HL)
                LD      (IX+pXTo),A
                INC     HL
                LD      A,(IX+pYTo)
                ADD     A,(HL)
                LD      (IX+pYTo),A
                LD      E,(IX+pAnimStep)
                LD      D,$00
                LD      HL,StepList
                LD      A,(IX+pSprNo)
                AND     $7F
                CP      LucySprite
                JR      C,MenStep
                LD      HL,LucyStepList
                CP      NosySprite
                JR      C,MenStep
                LD      HL,NosyStepList
MenStep:        LD      A,E
                ADD     HL,DE
                INC     A
                AND     $03
                LD      (IX+pAnimStep),A
                LD      A,(IX+pSprNo)
                ADD     A,(HL)
                LD      (IX+pSprNo),A
                LD      A,$FF
                LD      (SortFlag),A
                RET

GetDirect:      LD      A,$00
                LD      B,$00
                LD      HL,BounceTable+$00
                LD      C,$02
                CALL    DwDirect
                LD      HL,BounceTable+$02
                LD      C,$01
                CALL    DwDirect
                RET     C
                LD      HL,BounceTable+$04
                LD      C,$04
                CALL    DwDirect
                RET     C
                LD      HL,BounceTable+$06
                LD      C,$03
                CALL    DwDirect
                LD      A,B
                RET

DwDirect:       CP      (HL)
                RET     Z
                CP      B
                SCF
                RET     NZ
                LD      B,C
                OR      A
                RET

ConvToCruc:     LD      (IX+pObjType),MoveType
                LD      (IX+pSprNo),CrucifixSprite
                LD      A,(IX+pZReal)
                ADD     A,$08
                LD      (IX+pZReal),A
                CALL    GetSize
                CALL    RePosition
                CALL    ZeroTos
                LD      (IX+pAnimRout+$00),LOW AnimMove
                LD      (IX+pAnimRout+$01),HIGH AnimMove
                OR      A
                RET

ManAnim:        LD      A,(IX+pObjType)
                CP      NosyType
                JR      NZ,CheckWisOnly
                LD      A,(IX+pAnPower)
                XOR     $FF
                LD      (IX+pAnPower),A
                RET     P
                JP      DoneCheck

CheckWisOnly:   AND     $7F
                CP      WisType
                JR      Z,CheckWis
                LD      A,(IX+pPower)
                OR      A
                JR      NZ,DoneCheck
                SCF
                RET

CheckWis:       LD      A,(IX+pAnPower)
                OR      A
                JR      Z,ConvToCruc
DoneCheck:      LD      A,$00
                LD      (SortFlag),A
                DEC     A
                LD      (MoveFlag),A
                LD      A,(IX+pZFrom)
                CALL    ZeroFroms
                DEC     A
                JP      P,aNoGravity
                CALL    aGravity
                JR      NC,aFullGravity
aNoGravity:     CALL    aCheckMove
aFullGravity:   LD      A,(IX+pXTo)
                OR      (IX+pYTo)
                OR      (IX+pZTo)
                JR      Z,SkipNosy
                CALL    AnimXMove
                LD      B,(IX+pXTo)
                PUSH    BC
                LD      (IX+pXTo),$00
                CALL    AnimYMove
                CALL    AnimXMove
                POP     BC
                LD      A,(IX+pXTo)
                ADD     A,B
                LD      (IX+pXTo),A
                CALL    AnimZMove
                CALL    TransferTos
                LD      A,(MoveFlag)
                OR      A
                JR      Z,aHitSumit
                CALL    SortDrawList
SkipNosy:       LD      A,(SortFlag)
                ADD     A,A
                CCF
                RET

TransferTos:    LD      A,(IX+pXTo)
                LD      (IX+pXTo),$00
                LD      (IX+pXFrom),A
                LD      A,(IX+pYTo)
                LD      (IX+pYTo),$00
                LD      (IX+pYFrom),A
                LD      A,(IX+pZTo)
                LD      (IX+pZTo),$00
                LD      (IX+pZFrom),A
                RET

aHitSumit:      LD      A,R
                AND     $03
                INC     A
                CP      (IX+pDirect)
                JR      Z,aHitSumit
                CALL    NewDirect
                LD      A,(SortFlag)
                ADD     A,A
                CCF
                RET

aCheckMove:     LD      A,(IX+pObjType)
                CP      ManType
                JR      Z,NotHitChk
                CP      WisType
                JR      Z,NotHitChk
                LD      DE,(ManList)
                LD      HL,LucyList
                OR      A
                SBC     HL,DE
                JR      NZ,NotHitChk
                CP      NosyType
                JR      NZ,NotMoveNosy
                LD      A,$FF
                LD      (Following),A
NotMoveNosy:    LD      HL,pXReal
                ADD     HL,DE
                LD      A,(HL)
                SUB     (IX+pXReal)
                LD      C,$02
                JP      P,PosXReal
                NEG
                LD      C,$01
PosXReal:       LD      E,A
                INC     HL
                INC     HL
                LD      A,(HL)
                SUB     (IX+pYReal)
                LD      B,$04
                JP      P,PosYReal
                NEG
                LD      B,$03
PosYReal:       CP      E
                JP      NC,MoveNosyY
                LD      A,E
                CP      $18
                JR      NC,NotFollowing
                LD      A,C
                JP      ChkMovePlus

MoveNosyY:      CP      $18
                JR      NC,NotFollowing
                LD      A,B
                JP      ChkMovePlus

NotFollowing:   LD      A,(IX+pObjType)
                CP      NosyType
                JR      NZ,NotMoveNosy2
                LD      A,$00
                LD      (Following),A
NotMoveNosy2:   BIT     7,A
                JR      Z,NotHitChk
                PUSH    IX
                CALL    CheckNear
                LD      A,(IX+pSprNo)
                POP     IX
                JR      NC,NotHitChk
                CP      GarlicSprite
                JR      Z,aChangeDir
NotHitChk:      LD      A,R
                AND     $7F
                CP      $08
                LD      A,(IX+pDirect)
                JP      NC,ChkMovePlus
aChangeDir:     LD      A,R
                AND     $03
                INC     A
                JP      ChkMovePlus

                segment data
SortFlag:       DEFB    $00
MoveFlag:       DEFB    $00
Following:      DEFB    $00
                segment code

aGravity:       CALL    aDoGravity
                RET     C
                CALL    aDoGravity
                RET

Gravity:        CALL    DoGravity
                RET     C
                CALL    DoGravity
                RET

DoGravity:      LD      (IX+pHitType),$00
aDoGravity:     LD      A,(IX+pZReal)
                PUSH    AF
                DEC     A
                LD      (IX+pZReal),A
                DEC     (IX+pZFrom)
                PUSH    IX
                POP     DE
                CALL    WallCollide
                JR      C,GravityHit
                PUSH    IX
                PUSH    IX
                POP     DE
                CALL    GravCollide
                POP     IX
                JR      C,GravityHit

                POP     AF
                INC     (IX+pZFrom)
                LD      A,$FF
                LD      (SortFlag),A
                LD      (MoveFlag),A
                XOR     A
                RET

GravityHit:     POP     AF
                LD      (IX+pZReal),A
                INC     (IX+pZFrom)
                SCF
                RET


