                segment code

Convert         MACRO(Across,Down)
                LD      A,Across
                RRA
                RRA
                AND     $1F
                LD      L,A
                LD      A,Down
                RLCA
                RLCA
                LD      H,A
                AND     $E0
                OR      L
                LD      E,A
                LD      A,H
                AND     $03
                RLA
                RLA
                RLA
                LD      D,A
                LD      A,Down
                AND     $07
                OR      D
                LD      D,A
                LD      HL,DisplayFile
                ADD     HL,DE
                ENDM

PutLine         MACRO(Size)
                loop Size-$01
                LD      A,(HL)
                RRCA
                RRCA
                RRCA
                RRCA
                XOR     (HL)
                AND     $F0
                LD      C,A
                INC     HL
                LD      A,(HL)
                RRCA
                RRCA
                RRCA
                RRCA
                XOR     (HL)
                AND     $0F
                OR      C
                LD      (DE),A
                INC     HL
                INC     E
                lend
                LD      A,(HL)
                RRCA
                RRCA
                RRCA
                RRCA
                XOR     (HL)
                AND     $F0
                LD      C,A
                INC     HL
                LD      A,(HL)
                RRCA
                RRCA
                RRCA
                RRCA
                XOR     (HL)
                AND     $0F
                OR      C
                LD      (DE),A
                IF      DummyWidth <> Size-$01
                  IF      $02*DummyWidth-$02*Size+$01 >= $03
                    LD      A,L
                    ADD     A,$02*DummyWidth-$02*Size+$01
                    LD      L,A
                    ADC     A,H
                    SUB     L
                    LD      H,A
                  ELSE
                    loop $02*DummyWidth-$02*Size+$01
                      INC     HL
                      lend
                   ENDIF
                ENDIF
                IF      Size-$01 < $04
                  loop    Size-$01
                    DEC     E
                    lend
                ELSE
                  LD      A,E
                  SUB     Size-$01
                  LD      E,A
                ENDIF
                DEC     D
                LD      A,D
                AND     $07
                CP      $07
                JR      NZ,EndLine
                LD      A,E
                SUB     $20
                LD      E,A
                JP      C,EndLine
                LD      A,D
                ADD     A,$08
                LD      D,A
EndLine         EQU     $
                ENDM

//        org $a976
OutWindow:      Convert(C,B)
                PUSH    HL                      ;Point to real screen
                LD      A,(SizeWindX)
                RRA
                AND     $3E
                LD      E,A
                LD      D,$00
                LD      HL,PutTable
                ADD     HL,DE
                LD      C,(HL)
                INC     HL
                LD      B,(HL)
                POP     DE                      ;Point to screen
                LD      HL,DummyScreen          ;Point to dummy
                PUSH    BC
                LD      A,(SizeWindX+$01)
                LD      B,A
RetOut:         RET

PutTable:       DEFW    RetOut
                DEFW    Draw10
                DEFW    Draw20
                DEFW    Draw30
                DEFW    Draw40
                DEFW    Draw50

Draw10:         PutLine(1)
                DJNZ    Draw10
                RET

Draw20:         PutLine(2)
                DJNZ    Draw20
                RET

Draw30:         PutLine(3)
                DJNZ    Draw30
                RET

Draw40:         PutLine(4)
                DJNZ    Draw40
                RET

Draw50:         PutLine(5)
                DEC     B
                JP      NZ,Draw50
                RET

