                segment code

RotLine         MACRO(Width)
                POP     BC
                LD      A,C
                RRA
                RRA
                AND     $33
                LD      (DE),A
                INC     DE
                loop    (Width/2)-$01
                LD      A,C
                ADD     A,A
                ADD     A,A
                AND     $CC
                LD      L,A
                LD      A,B
                RRA
                RRA
                AND     $33
                OR      L
                LD      (DE),A
                INC     DE
                LD      A,B
                ADD     A,A
                ADD     A,A
                AND     $CC
                LD      L,A
                POP     BC
                LD      A,C
                RRA
                RRA
                AND     $33
                OR      L
                LD      (DE),A
                INC     DE
                lend
                LD      A,C
                ADD     A,A
                ADD     A,A
                AND     $CC
                LD      L,A
                LD      A,B
                RRA
                RRA
                AND     $33
                OR      L
                LD      (DE),A
                INC     DE
                LD      A,B
                ADD     A,A
                ADD     A,A
                AND     $CC
                LD      (DE),A
                INC     DE
                ENDM

Rotate:         DEC     L
                LD      A,E
                INC     E
                INC     E
                EX      AF,AF'
                LD      A,D
                PUSH    BC
                PUSH    DE
                PUSH    HL
                EXX
                PUSH    BC
                PUSH    HL
                EXX
                POP     HL
                LD      DE,(RotFree)
                EXX
                LD      HL,EndRotate
                PUSH    HL
                EX      AF,AF'
                CP      $04
                JP      Z,Rotate2
                CP      $08
                JP      Z,Rotate4
                CP      $0C
                JP      Z,Rotate6
                CP      $10
                JP      Z,Rotate8
                RET
EndRotate:      POP     BC
                INC     BC
                LD      HL,(RotFree)
                EXX
                POP     HL
                POP     DE
                POP     BC
                RET

Rotate2:        LD      (Stack002Rot),SP
                EXX
                DI
                LD      SP,HL
                EX      AF,AF'
                LD      H,A
RotLoop2:       RotLine(2)
                DEC     H
                JR      NZ,RotLoop2
                EXX
                LD      SP,$0000
Stack002Rot     EQU     $-$02
                EI
                RET

Rotate4:        LD      (Stack004Rot),SP
                EXX
                DI
                LD      SP,HL
                LD      H,A
                EX      AF,AF'
                LD      H,A
RotLoop4:       RotLine(4)
                DEC     H
                JR      NZ,RotLoop4
                EXX
                LD      SP,$0000
Stack004Rot     EQU     $-$02
                EI
                RET

Rotate6:        LD      (Stack006Rot),SP
                EXX
                DI
                LD      SP,HL
                EX      AF,AF'
                LD      H,A
RotLoop6:       RotLine(6)
                DEC     H
                JR      NZ,RotLoop6
                EXX
                LD      SP,$0000
Stack006Rot     EQU     $-$02
                EI
                RET

Rotate8:        LD      (Stack008Rot),SP
                EXX
                DI
                LD      SP,HL
                EX      AF,AF'
                LD      H,A
RotLoop8:       RotLine(8)
                DEC     H
                JR      NZ,RotLoop8
                EXX
                LD      SP,$0000
Stack008Rot     EQU     $-$02
                EI
                RET

                segment data

RotFree:        DEFW    $0000

                segment code

