                segment code

ReverseByte     MACRO()
                LD      A,(DE)
                LD      C,A
                LD      A,(BC)
                LD      C,(HL)
                LD      (HL),A
                LD      A,(BC)
                LD      (DE),A
                ENDM

RevLine         MACRO(Width)
                loop    (Width / $02)-$01
                  ReverseByte()
                  INC     DE
                  DEC     HL
                  lend
                ReverseByte()
                LD      A,E
                ADD     A,$01+(Width / 2)
                LD      E,A
                ADC     A,D
                SUB     E
                LD      D,A
                LD      HL,Width-$01
                ADD     HL,DE
                ENDM

Reverse:        LD      A,E
                CP      $04
                JP      Z,DoRev4
                CP      $06
                JP      Z,DoRev6
                CP      $08
                JP      Z,DoRev8
                CP      $0A
                JP      Z,DoRevA
                CP      $0C
                JP      Z,DoRevC
                RET

DoRev4:         LD      A,D
                EXX
                PUSH    HL
                PUSH    BC
                LD      B,HIGH RevTable
                LD      DE,$0003
                EX      DE,HL
                ADD     HL,DE
DoRev4Lp:       EX      AF,AF'
                RevLine(4)
                EX      AF,AF'
                DEC     A
                JR      NZ,DoRev4Lp
                POP     BC
                POP     HL
                EXX
                RET

DoRev6:         LD      A,D
                EXX
                PUSH    HL
                PUSH    BC
                LD      B,HIGH RevTable
                LD      DE,$0005
                EX      DE,HL
                ADD     HL,DE
DoRev6Lp:       EX      AF,AF'
                RevLine(6)
                EX      AF,AF'
                DEC     A
                JR      NZ,DoRev6Lp
                POP     BC
                POP     HL
                EXX
                RET

DoRev8:         LD      A,D
                EXX
                PUSH    HL
                PUSH    BC
                LD      B,HIGH RevTable
                LD      DE,$0007
                EX      DE,HL
                ADD     HL,DE
DoRev8Lp:       EX      AF,AF'
                RevLine(8)
                EX      AF,AF'
                DEC     A
                JR      NZ,DoRev8Lp
                POP     BC
                POP     HL
                EXX
                RET

DoRevA:         LD      A,D
                EXX
                PUSH    HL
                PUSH    BC
                LD      B,HIGH RevTable
                LD      DE,$0009
                EX      DE,HL
                ADD     HL,DE
DoRevALp:       EX      AF,AF'
                RevLine($0A)
                EX      AF,AF'
                DEC     A
                JR      NZ,DoRevALp
                POP     BC
                POP     HL
                EXX
                RET

DoRevC:         LD      A,D
                EXX
                PUSH    HL
                PUSH    BC
                LD      B,HIGH RevTable
                LD      DE,$000B
                EX      DE,HL
                ADD     HL,DE
DoRevCLp:       EX      AF,AF'
                RevLine($0C)
                EX      AF,AF'
                DEC     A
                JP      NZ,DoRevCLp
                POP     BC
                POP     HL
                EXX
                RET

