                segment code

SetTables:      LD      HL,RevTable
RevTabLp1:      LD      A,L
                LD      BC,00000
                ADD     A,A
                RR      C
                ADD     A,A
                RR      C
                ADD     A,A
                RR      C
                ADD     A,A
                RR      C
                LD      A,L
                RRA
                RL      B
                RRA
                RL      B
                RRA
                RL      B
                RRA
                RL      B
                LD      A,B
                OR      C
                LD      (HL),A
                INC     L
                JR      NZ,RevTabLp1
                LD      HL,MaskTable
SetMaskLp:      LD      A,L
                CPL
                LD      C,A
                RRCA
                RRCA
                RRCA
                RRCA
                AND     C
                LD      (HL),A
                INC     L
                JR      NZ,SetMaskLp
                RET

SetIntTable:    LD      HL,IntPage
SetIntLp:       LD      (HL),(HIGH IntPage)+$01
                INC     L
                JR      NZ,SetIntLp
                INC     H
                LD      (HL),(HIGH IntPage)+$01
                LD      HL,$0101*($01+HIGH IntPage)
                LD      DE,Interupt
                LD      A,$C3
                LD      (HL),A
                INC     HL
                LD      (HL),E
                INC     HL
                LD      (HL),D
                LD      A,HIGH IntPage
                LD      I,A
                IM      2
                RET

SetUpULA:       PUSH    IY
                PUSH    IX
                CP      $0F
                LD      C,A
                JR      NZ,OkayRoomColour
                LD      HL,(RoomPoint)
                LD      A,H
                XOR     L
                AND     $07
                INC     A
                LD      C,A
                LD      HL,(ManList)
                LD      DE,pPickSprite
                ADD     HL,DE
                LD      A,(HL)
                AND     $7F
                CP      LitLamp
                JR      Z,OkayRoomColour
                CP      DeedSprite
                JR      Z,OkayRoomColour
                LD      C,$0F
OkayRoomColour: LD      A,C
                LD      B,$00
                LD      IX,ColourTables
                LD      IY,NightTables
                LD      A,(Seconds)
                BIT     7,A
                JR      Z,DayTime
                LD      IY,ColourTables
                LD      IX,NightTables
DayTime:        ADD     IX,BC
                ADD     IY,BC
                LD      A,(IX)
                LD      HL,$5800
                LD      DE,$5801
                LD      BC,$01DF
                LD      (HL),A
                LDIR
                EX      DE,HL
                PUSH    HL
                LD      BC,$1C07
                LD      DE,$0022
                INC     L
                INC     L
VLoop:          PUSH    BC
                PUSH    HL
                LD      A,(IX+$00)
VInner:         LD      (HL),A
                INC     L
                DJNZ    VInner
                POP     HL
                ADD     HL,DE
                POP     BC
                LD      A,B
                SUB     $04
                LD      B,A
                DEC     C
                JR      NZ,VLoop
                POP     HL
                LD      DE,$0020
                LD      A,(IY+$00)
                LD      B,$08
VLoop2:         LD      (HL),A
                INC     L
                LD      (HL),A
                ADD     HL,DE
                LD      (HL),A
                DEC     L
                LD      (HL),A
                INC     L
                INC     L
                DJNZ    VLoop2
                INC     DE
                LD      B,$08
VLoop3:         LD      (HL),A
                INC     L
                LD      (HL),A
                OR      A
                SBC     HL,DE
                LD      (HL),A
                INC     L
                LD      (HL),A
                INC     L
                DJNZ    VLoop3
                LD      HL,$5A40
                LD      A,$46
                LD      B,$03
                CALL    BlockAttr
                LD      A,$44
                LD      B,$03
                CALL    BlockAttr
                LD      HL,$5A9A
                LD      B,$03
                LD      A,$43
                CALL    BlockAttr
                LD      HL,$5A5D
                LD      B,$05
                LD      A,$45
                CALL    BlockAttr
                POP     IX
                POP     IY
                RET

BlockAttr:      LD      DE,$001E
BlockLoop:      LD      (HL),A
                INC     L
                LD      (HL),A
                INC     L
                LD      (HL),A
                ADD     HL,DE
                DJNZ    BlockLoop
                RET

ColourTables:   DEFB    $00,$46,$47,$46,$45,$46,$47,$46
                DEFB    $43,$44,$43,$44,$43,$46,$47,$00

NightTables:    DEFB    $00,$44,$42,$43,$41,$44,$42,$43
                DEFB    $42,$41,$42,$41,$42,$44,$42,$00

